/*
  
        [a, b]    
0 <= a <= b < 100002,    . 
     ,       [0, 16]. 
            . 
 ,          0. 
 ,        a  a+1  , 
     (, +1)   0.

  
        3   a, b  c,   
 d  - 5    .     
,   [a, b]     c.     
  d,            -
     d.      200000 .

.

0 10 1
11
5 11 2
14 20 1
6
19
22

0
2
1
0   

   - (log n)      (2 .)
*/

#include <iostream>
#include <string>
#include <sstream>
#include <cmath>
using namespace std; 

const int MAXN = 100001;
int n, t[4*MAXN] = {0};

void push (int v) 
{
	if (t[v] != -1) {
		t[v*2] = t[v*2+1] = t[v];
		t[v] = -1;
	}
}
 
void update (int v, int tl, int tr, int l, int r, int color) 
{
	if (l > r)
		return;
	if (l == tl && tr == r)
		t[v] = color;
	else {
		push (v);
		int tm = (tl + tr) / 2;
		update (v*2, tl, tm, l, min(r,tm), color);
		update (v*2+1, tm+1, tr, max(l,tm+1), r, color);
	}
}
 
int get (int v, int tl, int tr, int pos) 
{
	if (tl == tr)
		return t[v];
	push (v);
	int tm = (tl + tr) / 2;
	if (pos <= tm)
		return get (v*2, tl, tm, pos);
	else
		return get (v*2+1, tm+1, tr, pos);
}

int main()
{
    string s;
    int n = MAXN;
    int a, b, c;
    double d;
    int i1, i2, pos;
    while(getline(cin, s))
    {         
              istringstream is(s);
              size_t found = s.find(' ');
              if (found != string::npos) // 3 
              {
                        is >> a >> b >> c;
                        update(1, 0, n - 1, a, b, c);
              }
              else                         // 1 
              {
                         is >> d;
                         pos = static_cast<int>(d);
                         if (fabs(d - pos) < 1e-7) 
                              cout << get(1, 0, n - 1, pos) << endl;           
                         else
                         {
                             i1 = get(1, 0, n - 1, pos);
                             i2 = get(1, 0, n - 1, pos + 1);
                             if (i1 == i2) cout << i1 << endl;
                             else cout << "0" << endl;
                         }
              } 
    }
    return 0;
}
